unit schFacturasClienteServer_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable, uDABusinessProcessor, schFacturasClienteClient_Intf;

const
  { Delta rules ids 
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_DarReferenciaFacturaDelta = '{B29E9CE6-95A1-40E8-A705-BD4294574ACC}';
  RID_FacturasClienteDelta = '{252073DF-06FC-4F6D-A9AA-FF8C6CFE03A3}';
  RID_DetallesFacturasClienteDelta = '{31E756BD-AB74-46CC-B517-1C3D8EE902B2}';
  RID_InformeCabeceraFacturaClienteDelta = '{A3EC9E7C-6FB3-4ED5-9F70-FC769B6CA6BA}';
  RID_InformeDetallesFacturaClienteDelta = '{CEB4700E-33CA-4DD9-94BA-768CB2667B50}';
  RID_DarReferenciaFacturaProformaDelta = '{D0FEFC95-863D-4E4C-B372-C1A8CCF97E52}';

type
  { IDarReferenciaFacturaDelta }
  IDarReferenciaFacturaDelta = interface(IDarReferenciaFactura)
  ['{B29E9CE6-95A1-40E8-A705-BD4294574ACC}']
    { Property getters and setters }
    function GetOldREFERENCIAValue : String;

    { Properties }
    property OldREFERENCIA : String read GetOldREFERENCIAValue;
  end;

  { TDarReferenciaFacturaBusinessProcessorRules }
  TDarReferenciaFacturaBusinessProcessorRules = class(TDABusinessProcessorRules, IDarReferenciaFactura, IDarReferenciaFacturaDelta)
  private
  protected
    { Property getters and setters }
    function GetREFERENCIAValue: String; virtual;
    function GetOldREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;

    { Properties }
    property REFERENCIA : String read GetREFERENCIAValue write SetREFERENCIAValue;
    property OldREFERENCIA : String read GetOldREFERENCIAValue;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

  { IFacturasClienteDelta }
  IFacturasClienteDelta = interface(IFacturasCliente)
  ['{252073DF-06FC-4F6D-A9AA-FF8C6CFE03A3}']
    { Property getters and setters }
    function GetOldCODIGOValue : Integer;
    function GetOldFECHAALTAValue : DateTime;
    function GetOldFECHAVENCIMIENTOValue : DateTime;
    function GetOldUSUARIOValue : String;
    function GetOldFECHAFACTURAValue : DateTime;
    function GetOldCLASEFACTURAValue : String;
    function GetOldREFERENCIAValue : String;
    function GetOldPAGADAValue : String;
    function GetOldBASEIMPONIBLEValue : Currency;
    function GetOldIVAValue : Float;
    function GetOldIMPORTEIVAValue : Currency;
    function GetOldIMPORTETOTALValue : Currency;
    function GetOldDESCUENTOValue : Float;
    function GetOldIMPORTEDESCUENTOValue : Float;
    function GetOldOBSERVACIONESValue : IROStrings;
    function GetOldFORMAPAGOValue : IROStrings;
    function GetOldCODIGOCONTACTOValue : Integer;
    function GetOldNIFCIFValue : String;
    function GetOldNOMBREValue : String;
    function GetOldCALLEValue : String;
    function GetOldPROVINCIAValue : String;
    function GetOldCODIGOPOSTALValue : String;
    function GetOldPOBLACIONValue : String;
    function GetOldCODIGOOBRAValue : Integer;

    { Properties }
    property OldCODIGO : Integer read GetOldCODIGOValue;
    property OldFECHAALTA : DateTime read GetOldFECHAALTAValue;
    property OldFECHAVENCIMIENTO : DateTime read GetOldFECHAVENCIMIENTOValue;
    property OldUSUARIO : String read GetOldUSUARIOValue;
    property OldFECHAFACTURA : DateTime read GetOldFECHAFACTURAValue;
    property OldCLASEFACTURA : String read GetOldCLASEFACTURAValue;
    property OldREFERENCIA : String read GetOldREFERENCIAValue;
    property OldPAGADA : String read GetOldPAGADAValue;
    property OldBASEIMPONIBLE : Currency read GetOldBASEIMPONIBLEValue;
    property OldIVA : Float read GetOldIVAValue;
    property OldIMPORTEIVA : Currency read GetOldIMPORTEIVAValue;
    property OldIMPORTETOTAL : Currency read GetOldIMPORTETOTALValue;
    property OldDESCUENTO : Float read GetOldDESCUENTOValue;
    property OldIMPORTEDESCUENTO : Float read GetOldIMPORTEDESCUENTOValue;
    property OldOBSERVACIONES : IROStrings read GetOldOBSERVACIONESValue;
    property OldFORMAPAGO : IROStrings read GetOldFORMAPAGOValue;
    property OldCODIGOCONTACTO : Integer read GetOldCODIGOCONTACTOValue;
    property OldNIFCIF : String read GetOldNIFCIFValue;
    property OldNOMBRE : String read GetOldNOMBREValue;
    property OldCALLE : String read GetOldCALLEValue;
    property OldPROVINCIA : String read GetOldPROVINCIAValue;
    property OldCODIGOPOSTAL : String read GetOldCODIGOPOSTALValue;
    property OldPOBLACION : String read GetOldPOBLACIONValue;
    property OldCODIGOOBRA : Integer read GetOldCODIGOOBRAValue;
  end;

  { TFacturasClienteBusinessProcessorRules }
  TFacturasClienteBusinessProcessorRules = class(TDABusinessProcessorRules, IFacturasCliente, IFacturasClienteDelta)
  private
  protected
    { Property getters and setters }
    function GetCODIGOValue: Integer; virtual;
    function GetOldCODIGOValue: Integer; virtual;
    procedure SetCODIGOValue(const aValue: Integer); virtual;
    function GetFECHAALTAValue: DateTime; virtual;
    function GetOldFECHAALTAValue: DateTime; virtual;
    procedure SetFECHAALTAValue(const aValue: DateTime); virtual;
    function GetFECHAVENCIMIENTOValue: DateTime; virtual;
    function GetOldFECHAVENCIMIENTOValue: DateTime; virtual;
    procedure SetFECHAVENCIMIENTOValue(const aValue: DateTime); virtual;
    function GetUSUARIOValue: String; virtual;
    function GetOldUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetFECHAFACTURAValue: DateTime; virtual;
    function GetOldFECHAFACTURAValue: DateTime; virtual;
    procedure SetFECHAFACTURAValue(const aValue: DateTime); virtual;
    function GetCLASEFACTURAValue: String; virtual;
    function GetOldCLASEFACTURAValue: String; virtual;
    procedure SetCLASEFACTURAValue(const aValue: String); virtual;
    function GetREFERENCIAValue: String; virtual;
    function GetOldREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetPAGADAValue: String; virtual;
    function GetOldPAGADAValue: String; virtual;
    procedure SetPAGADAValue(const aValue: String); virtual;
    function GetBASEIMPONIBLEValue: Currency; virtual;
    function GetOldBASEIMPONIBLEValue: Currency; virtual;
    procedure SetBASEIMPONIBLEValue(const aValue: Currency); virtual;
    function GetIVAValue: Float; virtual;
    function GetOldIVAValue: Float; virtual;
    procedure SetIVAValue(const aValue: Float); virtual;
    function GetIMPORTEIVAValue: Currency; virtual;
    function GetOldIMPORTEIVAValue: Currency; virtual;
    procedure SetIMPORTEIVAValue(const aValue: Currency); virtual;
    function GetIMPORTETOTALValue: Currency; virtual;
    function GetOldIMPORTETOTALValue: Currency; virtual;
    procedure SetIMPORTETOTALValue(const aValue: Currency); virtual;
    function GetDESCUENTOValue: Float; virtual;
    function GetOldDESCUENTOValue: Float; virtual;
    procedure SetDESCUENTOValue(const aValue: Float); virtual;
    function GetIMPORTEDESCUENTOValue: Float; virtual;
    function GetOldIMPORTEDESCUENTOValue: Float; virtual;
    procedure SetIMPORTEDESCUENTOValue(const aValue: Float); virtual;
    function GetOBSERVACIONESValue: IROStrings; virtual;
    function GetOldOBSERVACIONESValue: IROStrings; virtual;
    procedure SetOBSERVACIONESValue(const aValue: IROStrings); virtual;
    function GetFORMAPAGOValue: IROStrings; virtual;
    function GetOldFORMAPAGOValue: IROStrings; virtual;
    procedure SetFORMAPAGOValue(const aValue: IROStrings); virtual;
    function GetCODIGOCONTACTOValue: Integer; virtual;
    function GetOldCODIGOCONTACTOValue: Integer; virtual;
    procedure SetCODIGOCONTACTOValue(const aValue: Integer); virtual;
    function GetNIFCIFValue: String; virtual;
    function GetOldNIFCIFValue: String; virtual;
    procedure SetNIFCIFValue(const aValue: String); virtual;
    function GetNOMBREValue: String; virtual;
    function GetOldNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    function GetCALLEValue: String; virtual;
    function GetOldCALLEValue: String; virtual;
    procedure SetCALLEValue(const aValue: String); virtual;
    function GetPROVINCIAValue: String; virtual;
    function GetOldPROVINCIAValue: String; virtual;
    procedure SetPROVINCIAValue(const aValue: String); virtual;
    function GetCODIGOPOSTALValue: String; virtual;
    function GetOldCODIGOPOSTALValue: String; virtual;
    procedure SetCODIGOPOSTALValue(const aValue: String); virtual;
    function GetPOBLACIONValue: String; virtual;
    function GetOldPOBLACIONValue: String; virtual;
    procedure SetPOBLACIONValue(const aValue: String); virtual;
    function GetCODIGOOBRAValue: Integer; virtual;
    function GetOldCODIGOOBRAValue: Integer; virtual;
    procedure SetCODIGOOBRAValue(const aValue: Integer); virtual;

    { Properties }
    property CODIGO : Integer read GetCODIGOValue write SetCODIGOValue;
    property OldCODIGO : Integer read GetOldCODIGOValue;
    property FECHAALTA : DateTime read GetFECHAALTAValue write SetFECHAALTAValue;
    property OldFECHAALTA : DateTime read GetOldFECHAALTAValue;
    property FECHAVENCIMIENTO : DateTime read GetFECHAVENCIMIENTOValue write SetFECHAVENCIMIENTOValue;
    property OldFECHAVENCIMIENTO : DateTime read GetOldFECHAVENCIMIENTOValue;
    property USUARIO : String read GetUSUARIOValue write SetUSUARIOValue;
    property OldUSUARIO : String read GetOldUSUARIOValue;
    property FECHAFACTURA : DateTime read GetFECHAFACTURAValue write SetFECHAFACTURAValue;
    property OldFECHAFACTURA : DateTime read GetOldFECHAFACTURAValue;
    property CLASEFACTURA : String read GetCLASEFACTURAValue write SetCLASEFACTURAValue;
    property OldCLASEFACTURA : String read GetOldCLASEFACTURAValue;
    property REFERENCIA : String read GetREFERENCIAValue write SetREFERENCIAValue;
    property OldREFERENCIA : String read GetOldREFERENCIAValue;
    property PAGADA : String read GetPAGADAValue write SetPAGADAValue;
    property OldPAGADA : String read GetOldPAGADAValue;
    property BASEIMPONIBLE : Currency read GetBASEIMPONIBLEValue write SetBASEIMPONIBLEValue;
    property OldBASEIMPONIBLE : Currency read GetOldBASEIMPONIBLEValue;
    property IVA : Float read GetIVAValue write SetIVAValue;
    property OldIVA : Float read GetOldIVAValue;
    property IMPORTEIVA : Currency read GetIMPORTEIVAValue write SetIMPORTEIVAValue;
    property OldIMPORTEIVA : Currency read GetOldIMPORTEIVAValue;
    property IMPORTETOTAL : Currency read GetIMPORTETOTALValue write SetIMPORTETOTALValue;
    property OldIMPORTETOTAL : Currency read GetOldIMPORTETOTALValue;
    property DESCUENTO : Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property OldDESCUENTO : Float read GetOldDESCUENTOValue;
    property IMPORTEDESCUENTO : Float read GetIMPORTEDESCUENTOValue write SetIMPORTEDESCUENTOValue;
    property OldIMPORTEDESCUENTO : Float read GetOldIMPORTEDESCUENTOValue;
    property OBSERVACIONES : IROStrings read GetOBSERVACIONESValue write SetOBSERVACIONESValue;
    property OldOBSERVACIONES : IROStrings read GetOldOBSERVACIONESValue;
    property FORMAPAGO : IROStrings read GetFORMAPAGOValue write SetFORMAPAGOValue;
    property OldFORMAPAGO : IROStrings read GetOldFORMAPAGOValue;
    property CODIGOCONTACTO : Integer read GetCODIGOCONTACTOValue write SetCODIGOCONTACTOValue;
    property OldCODIGOCONTACTO : Integer read GetOldCODIGOCONTACTOValue;
    property NIFCIF : String read GetNIFCIFValue write SetNIFCIFValue;
    property OldNIFCIF : String read GetOldNIFCIFValue;
    property NOMBRE : String read GetNOMBREValue write SetNOMBREValue;
    property OldNOMBRE : String read GetOldNOMBREValue;
    property CALLE : String read GetCALLEValue write SetCALLEValue;
    property OldCALLE : String read GetOldCALLEValue;
    property PROVINCIA : String read GetPROVINCIAValue write SetPROVINCIAValue;
    property OldPROVINCIA : String read GetOldPROVINCIAValue;
    property CODIGOPOSTAL : String read GetCODIGOPOSTALValue write SetCODIGOPOSTALValue;
    property OldCODIGOPOSTAL : String read GetOldCODIGOPOSTALValue;
    property POBLACION : String read GetPOBLACIONValue write SetPOBLACIONValue;
    property OldPOBLACION : String read GetOldPOBLACIONValue;
    property CODIGOOBRA : Integer read GetCODIGOOBRAValue write SetCODIGOOBRAValue;
    property OldCODIGOOBRA : Integer read GetOldCODIGOOBRAValue;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

  { IDetallesFacturasClienteDelta }
  IDetallesFacturasClienteDelta = interface(IDetallesFacturasCliente)
  ['{31E756BD-AB74-46CC-B517-1C3D8EE902B2}']
    { Property getters and setters }
    function GetOldCODIGOFACTURAValue : Integer;
    function GetOldNUMCONCEPTOValue : Integer;
    function GetOldPOSICIONValue : Integer;
    function GetOldTIPOValue : String;
    function GetOldDESCRIPCIONValue : String;
    function GetOldCANTIDADValue : Integer;
    function GetOldIMPORTEUNIDADValue : Currency;
    function GetOldIMPORTETOTALValue : Currency;

    { Properties }
    property OldCODIGOFACTURA : Integer read GetOldCODIGOFACTURAValue;
    property OldNUMCONCEPTO : Integer read GetOldNUMCONCEPTOValue;
    property OldPOSICION : Integer read GetOldPOSICIONValue;
    property OldTIPO : String read GetOldTIPOValue;
    property OldDESCRIPCION : String read GetOldDESCRIPCIONValue;
    property OldCANTIDAD : Integer read GetOldCANTIDADValue;
    property OldIMPORTEUNIDAD : Currency read GetOldIMPORTEUNIDADValue;
    property OldIMPORTETOTAL : Currency read GetOldIMPORTETOTALValue;
  end;

  { TDetallesFacturasClienteBusinessProcessorRules }
  TDetallesFacturasClienteBusinessProcessorRules = class(TDABusinessProcessorRules, IDetallesFacturasCliente, IDetallesFacturasClienteDelta)
  private
  protected
    { Property getters and setters }
    function GetCODIGOFACTURAValue: Integer; virtual;
    function GetOldCODIGOFACTURAValue: Integer; virtual;
    procedure SetCODIGOFACTURAValue(const aValue: Integer); virtual;
    function GetNUMCONCEPTOValue: Integer; virtual;
    function GetOldNUMCONCEPTOValue: Integer; virtual;
    procedure SetNUMCONCEPTOValue(const aValue: Integer); virtual;
    function GetPOSICIONValue: Integer; virtual;
    function GetOldPOSICIONValue: Integer; virtual;
    procedure SetPOSICIONValue(const aValue: Integer); virtual;
    function GetTIPOValue: String; virtual;
    function GetOldTIPOValue: String; virtual;
    procedure SetTIPOValue(const aValue: String); virtual;
    function GetDESCRIPCIONValue: String; virtual;
    function GetOldDESCRIPCIONValue: String; virtual;
    procedure SetDESCRIPCIONValue(const aValue: String); virtual;
    function GetCANTIDADValue: Integer; virtual;
    function GetOldCANTIDADValue: Integer; virtual;
    procedure SetCANTIDADValue(const aValue: Integer); virtual;
    function GetIMPORTEUNIDADValue: Currency; virtual;
    function GetOldIMPORTEUNIDADValue: Currency; virtual;
    procedure SetIMPORTEUNIDADValue(const aValue: Currency); virtual;
    function GetIMPORTETOTALValue: Currency; virtual;
    function GetOldIMPORTETOTALValue: Currency; virtual;
    procedure SetIMPORTETOTALValue(const aValue: Currency); virtual;

    { Properties }
    property CODIGOFACTURA : Integer read GetCODIGOFACTURAValue write SetCODIGOFACTURAValue;
    property OldCODIGOFACTURA : Integer read GetOldCODIGOFACTURAValue;
    property NUMCONCEPTO : Integer read GetNUMCONCEPTOValue write SetNUMCONCEPTOValue;
    property OldNUMCONCEPTO : Integer read GetOldNUMCONCEPTOValue;
    property POSICION : Integer read GetPOSICIONValue write SetPOSICIONValue;
    property OldPOSICION : Integer read GetOldPOSICIONValue;
    property TIPO : String read GetTIPOValue write SetTIPOValue;
    property OldTIPO : String read GetOldTIPOValue;
    property DESCRIPCION : String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property OldDESCRIPCION : String read GetOldDESCRIPCIONValue;
    property CANTIDAD : Integer read GetCANTIDADValue write SetCANTIDADValue;
    property OldCANTIDAD : Integer read GetOldCANTIDADValue;
    property IMPORTEUNIDAD : Currency read GetIMPORTEUNIDADValue write SetIMPORTEUNIDADValue;
    property OldIMPORTEUNIDAD : Currency read GetOldIMPORTEUNIDADValue;
    property IMPORTETOTAL : Currency read GetIMPORTETOTALValue write SetIMPORTETOTALValue;
    property OldIMPORTETOTAL : Currency read GetOldIMPORTETOTALValue;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

  { IInformeCabeceraFacturaClienteDelta }
  IInformeCabeceraFacturaClienteDelta = interface(IInformeCabeceraFacturaCliente)
  ['{A3EC9E7C-6FB3-4ED5-9F70-FC769B6CA6BA}']
    { Property getters and setters }
    function GetOldCODIGOValue : Integer;
    function GetOldFECHAALTAValue : DateTime;
    function GetOldFECHAVENCIMIENTOValue : DateTime;
    function GetOldUSUARIOValue : String;
    function GetOldCLASEFACTURAValue : String;
    function GetOldFECHAFACTURAValue : DateTime;
    function GetOldREFERENCIAValue : String;
    function GetOldPAGADAValue : String;
    function GetOldCODIGOCONTACTOValue : Integer;
    function GetOldBASEIMPONIBLEValue : Currency;
    function GetOldIVAValue : Float;
    function GetOldIMPORTEIVAValue : Currency;
    function GetOldIMPORTETOTALValue : Currency;
    function GetOldOBSERVACIONESValue : IROStrings;
    function GetOldFORMAPAGOValue : IROStrings;
    function GetOldNIFCIFValue : String;
    function GetOldNOMBREValue : String;
    function GetOldCALLEValue : String;
    function GetOldPROVINCIAValue : String;
    function GetOldCODIGOPOSTALValue : String;
    function GetOldPOBLACIONValue : String;
    function GetOldCODIGOOBRAValue : Integer;

    { Properties }
    property OldCODIGO : Integer read GetOldCODIGOValue;
    property OldFECHAALTA : DateTime read GetOldFECHAALTAValue;
    property OldFECHAVENCIMIENTO : DateTime read GetOldFECHAVENCIMIENTOValue;
    property OldUSUARIO : String read GetOldUSUARIOValue;
    property OldCLASEFACTURA : String read GetOldCLASEFACTURAValue;
    property OldFECHAFACTURA : DateTime read GetOldFECHAFACTURAValue;
    property OldREFERENCIA : String read GetOldREFERENCIAValue;
    property OldPAGADA : String read GetOldPAGADAValue;
    property OldCODIGOCONTACTO : Integer read GetOldCODIGOCONTACTOValue;
    property OldBASEIMPONIBLE : Currency read GetOldBASEIMPONIBLEValue;
    property OldIVA : Float read GetOldIVAValue;
    property OldIMPORTEIVA : Currency read GetOldIMPORTEIVAValue;
    property OldIMPORTETOTAL : Currency read GetOldIMPORTETOTALValue;
    property OldOBSERVACIONES : IROStrings read GetOldOBSERVACIONESValue;
    property OldFORMAPAGO : IROStrings read GetOldFORMAPAGOValue;
    property OldNIFCIF : String read GetOldNIFCIFValue;
    property OldNOMBRE : String read GetOldNOMBREValue;
    property OldCALLE : String read GetOldCALLEValue;
    property OldPROVINCIA : String read GetOldPROVINCIAValue;
    property OldCODIGOPOSTAL : String read GetOldCODIGOPOSTALValue;
    property OldPOBLACION : String read GetOldPOBLACIONValue;
    property OldCODIGOOBRA : Integer read GetOldCODIGOOBRAValue;
  end;

  { TInformeCabeceraFacturaClienteBusinessProcessorRules }
  TInformeCabeceraFacturaClienteBusinessProcessorRules = class(TDABusinessProcessorRules, IInformeCabeceraFacturaCliente, IInformeCabeceraFacturaClienteDelta)
  private
  protected
    { Property getters and setters }
    function GetCODIGOValue: Integer; virtual;
    function GetOldCODIGOValue: Integer; virtual;
    procedure SetCODIGOValue(const aValue: Integer); virtual;
    function GetFECHAALTAValue: DateTime; virtual;
    function GetOldFECHAALTAValue: DateTime; virtual;
    procedure SetFECHAALTAValue(const aValue: DateTime); virtual;
    function GetFECHAVENCIMIENTOValue: DateTime; virtual;
    function GetOldFECHAVENCIMIENTOValue: DateTime; virtual;
    procedure SetFECHAVENCIMIENTOValue(const aValue: DateTime); virtual;
    function GetUSUARIOValue: String; virtual;
    function GetOldUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetCLASEFACTURAValue: String; virtual;
    function GetOldCLASEFACTURAValue: String; virtual;
    procedure SetCLASEFACTURAValue(const aValue: String); virtual;
    function GetFECHAFACTURAValue: DateTime; virtual;
    function GetOldFECHAFACTURAValue: DateTime; virtual;
    procedure SetFECHAFACTURAValue(const aValue: DateTime); virtual;
    function GetREFERENCIAValue: String; virtual;
    function GetOldREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetPAGADAValue: String; virtual;
    function GetOldPAGADAValue: String; virtual;
    procedure SetPAGADAValue(const aValue: String); virtual;
    function GetCODIGOCONTACTOValue: Integer; virtual;
    function GetOldCODIGOCONTACTOValue: Integer; virtual;
    procedure SetCODIGOCONTACTOValue(const aValue: Integer); virtual;
    function GetBASEIMPONIBLEValue: Currency; virtual;
    function GetOldBASEIMPONIBLEValue: Currency; virtual;
    procedure SetBASEIMPONIBLEValue(const aValue: Currency); virtual;
    function GetIVAValue: Float; virtual;
    function GetOldIVAValue: Float; virtual;
    procedure SetIVAValue(const aValue: Float); virtual;
    function GetIMPORTEIVAValue: Currency; virtual;
    function GetOldIMPORTEIVAValue: Currency; virtual;
    procedure SetIMPORTEIVAValue(const aValue: Currency); virtual;
    function GetIMPORTETOTALValue: Currency; virtual;
    function GetOldIMPORTETOTALValue: Currency; virtual;
    procedure SetIMPORTETOTALValue(const aValue: Currency); virtual;
    function GetOBSERVACIONESValue: IROStrings; virtual;
    function GetOldOBSERVACIONESValue: IROStrings; virtual;
    procedure SetOBSERVACIONESValue(const aValue: IROStrings); virtual;
    function GetFORMAPAGOValue: IROStrings; virtual;
    function GetOldFORMAPAGOValue: IROStrings; virtual;
    procedure SetFORMAPAGOValue(const aValue: IROStrings); virtual;
    function GetNIFCIFValue: String; virtual;
    function GetOldNIFCIFValue: String; virtual;
    procedure SetNIFCIFValue(const aValue: String); virtual;
    function GetNOMBREValue: String; virtual;
    function GetOldNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    function GetCALLEValue: String; virtual;
    function GetOldCALLEValue: String; virtual;
    procedure SetCALLEValue(const aValue: String); virtual;
    function GetPROVINCIAValue: String; virtual;
    function GetOldPROVINCIAValue: String; virtual;
    procedure SetPROVINCIAValue(const aValue: String); virtual;
    function GetCODIGOPOSTALValue: String; virtual;
    function GetOldCODIGOPOSTALValue: String; virtual;
    procedure SetCODIGOPOSTALValue(const aValue: String); virtual;
    function GetPOBLACIONValue: String; virtual;
    function GetOldPOBLACIONValue: String; virtual;
    procedure SetPOBLACIONValue(const aValue: String); virtual;
    function GetCODIGOOBRAValue: Integer; virtual;
    function GetOldCODIGOOBRAValue: Integer; virtual;
    procedure SetCODIGOOBRAValue(const aValue: Integer); virtual;

    { Properties }
    property CODIGO : Integer read GetCODIGOValue write SetCODIGOValue;
    property OldCODIGO : Integer read GetOldCODIGOValue;
    property FECHAALTA : DateTime read GetFECHAALTAValue write SetFECHAALTAValue;
    property OldFECHAALTA : DateTime read GetOldFECHAALTAValue;
    property FECHAVENCIMIENTO : DateTime read GetFECHAVENCIMIENTOValue write SetFECHAVENCIMIENTOValue;
    property OldFECHAVENCIMIENTO : DateTime read GetOldFECHAVENCIMIENTOValue;
    property USUARIO : String read GetUSUARIOValue write SetUSUARIOValue;
    property OldUSUARIO : String read GetOldUSUARIOValue;
    property CLASEFACTURA : String read GetCLASEFACTURAValue write SetCLASEFACTURAValue;
    property OldCLASEFACTURA : String read GetOldCLASEFACTURAValue;
    property FECHAFACTURA : DateTime read GetFECHAFACTURAValue write SetFECHAFACTURAValue;
    property OldFECHAFACTURA : DateTime read GetOldFECHAFACTURAValue;
    property REFERENCIA : String read GetREFERENCIAValue write SetREFERENCIAValue;
    property OldREFERENCIA : String read GetOldREFERENCIAValue;
    property PAGADA : String read GetPAGADAValue write SetPAGADAValue;
    property OldPAGADA : String read GetOldPAGADAValue;
    property CODIGOCONTACTO : Integer read GetCODIGOCONTACTOValue write SetCODIGOCONTACTOValue;
    property OldCODIGOCONTACTO : Integer read GetOldCODIGOCONTACTOValue;
    property BASEIMPONIBLE : Currency read GetBASEIMPONIBLEValue write SetBASEIMPONIBLEValue;
    property OldBASEIMPONIBLE : Currency read GetOldBASEIMPONIBLEValue;
    property IVA : Float read GetIVAValue write SetIVAValue;
    property OldIVA : Float read GetOldIVAValue;
    property IMPORTEIVA : Currency read GetIMPORTEIVAValue write SetIMPORTEIVAValue;
    property OldIMPORTEIVA : Currency read GetOldIMPORTEIVAValue;
    property IMPORTETOTAL : Currency read GetIMPORTETOTALValue write SetIMPORTETOTALValue;
    property OldIMPORTETOTAL : Currency read GetOldIMPORTETOTALValue;
    property OBSERVACIONES : IROStrings read GetOBSERVACIONESValue write SetOBSERVACIONESValue;
    property OldOBSERVACIONES : IROStrings read GetOldOBSERVACIONESValue;
    property FORMAPAGO : IROStrings read GetFORMAPAGOValue write SetFORMAPAGOValue;
    property OldFORMAPAGO : IROStrings read GetOldFORMAPAGOValue;
    property NIFCIF : String read GetNIFCIFValue write SetNIFCIFValue;
    property OldNIFCIF : String read GetOldNIFCIFValue;
    property NOMBRE : String read GetNOMBREValue write SetNOMBREValue;
    property OldNOMBRE : String read GetOldNOMBREValue;
    property CALLE : String read GetCALLEValue write SetCALLEValue;
    property OldCALLE : String read GetOldCALLEValue;
    property PROVINCIA : String read GetPROVINCIAValue write SetPROVINCIAValue;
    property OldPROVINCIA : String read GetOldPROVINCIAValue;
    property CODIGOPOSTAL : String read GetCODIGOPOSTALValue write SetCODIGOPOSTALValue;
    property OldCODIGOPOSTAL : String read GetOldCODIGOPOSTALValue;
    property POBLACION : String read GetPOBLACIONValue write SetPOBLACIONValue;
    property OldPOBLACION : String read GetOldPOBLACIONValue;
    property CODIGOOBRA : Integer read GetCODIGOOBRAValue write SetCODIGOOBRAValue;
    property OldCODIGOOBRA : Integer read GetOldCODIGOOBRAValue;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

  { IInformeDetallesFacturaClienteDelta }
  IInformeDetallesFacturaClienteDelta = interface(IInformeDetallesFacturaCliente)
  ['{CEB4700E-33CA-4DD9-94BA-768CB2667B50}']
    { Property getters and setters }
    function GetOldCODIGOFACTURAValue : Integer;
    function GetOldNUMCONCEPTOValue : Integer;
    function GetOldDESCRIPCIONValue : String;
    function GetOldCANTIDADValue : Float;
    function GetOldIMPORTEUNIDADValue : Currency;
    function GetOldIMPORTETOTALValue : Currency;
    function GetOldTIPOValue : String;
    function GetOldPOSICIONValue : Integer;

    { Properties }
    property OldCODIGOFACTURA : Integer read GetOldCODIGOFACTURAValue;
    property OldNUMCONCEPTO : Integer read GetOldNUMCONCEPTOValue;
    property OldDESCRIPCION : String read GetOldDESCRIPCIONValue;
    property OldCANTIDAD : Float read GetOldCANTIDADValue;
    property OldIMPORTEUNIDAD : Currency read GetOldIMPORTEUNIDADValue;
    property OldIMPORTETOTAL : Currency read GetOldIMPORTETOTALValue;
    property OldTIPO : String read GetOldTIPOValue;
    property OldPOSICION : Integer read GetOldPOSICIONValue;
  end;

  { TInformeDetallesFacturaClienteBusinessProcessorRules }
  TInformeDetallesFacturaClienteBusinessProcessorRules = class(TDABusinessProcessorRules, IInformeDetallesFacturaCliente, IInformeDetallesFacturaClienteDelta)
  private
  protected
    { Property getters and setters }
    function GetCODIGOFACTURAValue: Integer; virtual;
    function GetOldCODIGOFACTURAValue: Integer; virtual;
    procedure SetCODIGOFACTURAValue(const aValue: Integer); virtual;
    function GetNUMCONCEPTOValue: Integer; virtual;
    function GetOldNUMCONCEPTOValue: Integer; virtual;
    procedure SetNUMCONCEPTOValue(const aValue: Integer); virtual;
    function GetDESCRIPCIONValue: String; virtual;
    function GetOldDESCRIPCIONValue: String; virtual;
    procedure SetDESCRIPCIONValue(const aValue: String); virtual;
    function GetCANTIDADValue: Float; virtual;
    function GetOldCANTIDADValue: Float; virtual;
    procedure SetCANTIDADValue(const aValue: Float); virtual;
    function GetIMPORTEUNIDADValue: Currency; virtual;
    function GetOldIMPORTEUNIDADValue: Currency; virtual;
    procedure SetIMPORTEUNIDADValue(const aValue: Currency); virtual;
    function GetIMPORTETOTALValue: Currency; virtual;
    function GetOldIMPORTETOTALValue: Currency; virtual;
    procedure SetIMPORTETOTALValue(const aValue: Currency); virtual;
    function GetTIPOValue: String; virtual;
    function GetOldTIPOValue: String; virtual;
    procedure SetTIPOValue(const aValue: String); virtual;
    function GetPOSICIONValue: Integer; virtual;
    function GetOldPOSICIONValue: Integer; virtual;
    procedure SetPOSICIONValue(const aValue: Integer); virtual;

    { Properties }
    property CODIGOFACTURA : Integer read GetCODIGOFACTURAValue write SetCODIGOFACTURAValue;
    property OldCODIGOFACTURA : Integer read GetOldCODIGOFACTURAValue;
    property NUMCONCEPTO : Integer read GetNUMCONCEPTOValue write SetNUMCONCEPTOValue;
    property OldNUMCONCEPTO : Integer read GetOldNUMCONCEPTOValue;
    property DESCRIPCION : String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property OldDESCRIPCION : String read GetOldDESCRIPCIONValue;
    property CANTIDAD : Float read GetCANTIDADValue write SetCANTIDADValue;
    property OldCANTIDAD : Float read GetOldCANTIDADValue;
    property IMPORTEUNIDAD : Currency read GetIMPORTEUNIDADValue write SetIMPORTEUNIDADValue;
    property OldIMPORTEUNIDAD : Currency read GetOldIMPORTEUNIDADValue;
    property IMPORTETOTAL : Currency read GetIMPORTETOTALValue write SetIMPORTETOTALValue;
    property OldIMPORTETOTAL : Currency read GetOldIMPORTETOTALValue;
    property TIPO : String read GetTIPOValue write SetTIPOValue;
    property OldTIPO : String read GetOldTIPOValue;
    property POSICION : Integer read GetPOSICIONValue write SetPOSICIONValue;
    property OldPOSICION : Integer read GetOldPOSICIONValue;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

  { IDarReferenciaFacturaProformaDelta }
  IDarReferenciaFacturaProformaDelta = interface(IDarReferenciaFacturaProforma)
  ['{D0FEFC95-863D-4E4C-B372-C1A8CCF97E52}']
    { Property getters and setters }
    function GetOldREFERENCIAValue : String;

    { Properties }
    property OldREFERENCIA : String read GetOldREFERENCIAValue;
  end;

  { TDarReferenciaFacturaProformaBusinessProcessorRules }
  TDarReferenciaFacturaProformaBusinessProcessorRules = class(TDABusinessProcessorRules, IDarReferenciaFacturaProforma, IDarReferenciaFacturaProformaDelta)
  private
  protected
    { Property getters and setters }
    function GetREFERENCIAValue: String; virtual;
    function GetOldREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;

    { Properties }
    property REFERENCIA : String read GetREFERENCIAValue write SetREFERENCIAValue;
    property OldREFERENCIA : String read GetOldREFERENCIAValue;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

implementation

uses
  Variants, uROBinaryHelpers;

{ TDarReferenciaFacturaBusinessProcessorRules }
constructor TDarReferenciaFacturaBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TDarReferenciaFacturaBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TDarReferenciaFacturaBusinessProcessorRules.GetREFERENCIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_DarReferenciaFacturaREFERENCIA];
end;

function TDarReferenciaFacturaBusinessProcessorRules.GetOldREFERENCIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_DarReferenciaFacturaREFERENCIA];
end;

procedure TDarReferenciaFacturaBusinessProcessorRules.SetREFERENCIAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_DarReferenciaFacturaREFERENCIA] := aValue;
end;


{ TFacturasClienteBusinessProcessorRules }
constructor TFacturasClienteBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TFacturasClienteBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TFacturasClienteBusinessProcessorRules.GetCODIGOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteCODIGO];
end;

function TFacturasClienteBusinessProcessorRules.GetOldCODIGOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_FacturasClienteCODIGO];
end;

procedure TFacturasClienteBusinessProcessorRules.SetCODIGOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteCODIGO] := aValue;
end;

function TFacturasClienteBusinessProcessorRules.GetFECHAALTAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteFECHAALTA];
end;

function TFacturasClienteBusinessProcessorRules.GetOldFECHAALTAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_FacturasClienteFECHAALTA];
end;

procedure TFacturasClienteBusinessProcessorRules.SetFECHAALTAValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteFECHAALTA] := aValue;
end;

function TFacturasClienteBusinessProcessorRules.GetFECHAVENCIMIENTOValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteFECHAVENCIMIENTO];
end;

function TFacturasClienteBusinessProcessorRules.GetOldFECHAVENCIMIENTOValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_FacturasClienteFECHAVENCIMIENTO];
end;

procedure TFacturasClienteBusinessProcessorRules.SetFECHAVENCIMIENTOValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteFECHAVENCIMIENTO] := aValue;
end;

function TFacturasClienteBusinessProcessorRules.GetUSUARIOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteUSUARIO];
end;

function TFacturasClienteBusinessProcessorRules.GetOldUSUARIOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_FacturasClienteUSUARIO];
end;

procedure TFacturasClienteBusinessProcessorRules.SetUSUARIOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteUSUARIO] := aValue;
end;

function TFacturasClienteBusinessProcessorRules.GetFECHAFACTURAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteFECHAFACTURA];
end;

function TFacturasClienteBusinessProcessorRules.GetOldFECHAFACTURAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_FacturasClienteFECHAFACTURA];
end;

procedure TFacturasClienteBusinessProcessorRules.SetFECHAFACTURAValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteFECHAFACTURA] := aValue;
end;

function TFacturasClienteBusinessProcessorRules.GetCLASEFACTURAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteCLASEFACTURA];
end;

function TFacturasClienteBusinessProcessorRules.GetOldCLASEFACTURAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_FacturasClienteCLASEFACTURA];
end;

procedure TFacturasClienteBusinessProcessorRules.SetCLASEFACTURAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteCLASEFACTURA] := aValue;
end;

function TFacturasClienteBusinessProcessorRules.GetREFERENCIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteREFERENCIA];
end;

function TFacturasClienteBusinessProcessorRules.GetOldREFERENCIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_FacturasClienteREFERENCIA];
end;

procedure TFacturasClienteBusinessProcessorRules.SetREFERENCIAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteREFERENCIA] := aValue;
end;

function TFacturasClienteBusinessProcessorRules.GetPAGADAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClientePAGADA];
end;

function TFacturasClienteBusinessProcessorRules.GetOldPAGADAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_FacturasClientePAGADA];
end;

procedure TFacturasClienteBusinessProcessorRules.SetPAGADAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClientePAGADA] := aValue;
end;

function TFacturasClienteBusinessProcessorRules.GetBASEIMPONIBLEValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteBASEIMPONIBLE];
end;

function TFacturasClienteBusinessProcessorRules.GetOldBASEIMPONIBLEValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_FacturasClienteBASEIMPONIBLE];
end;

procedure TFacturasClienteBusinessProcessorRules.SetBASEIMPONIBLEValue(const aValue: Currency);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteBASEIMPONIBLE] := aValue;
end;

function TFacturasClienteBusinessProcessorRules.GetIVAValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteIVA];
end;

function TFacturasClienteBusinessProcessorRules.GetOldIVAValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_FacturasClienteIVA];
end;

procedure TFacturasClienteBusinessProcessorRules.SetIVAValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteIVA] := aValue;
end;

function TFacturasClienteBusinessProcessorRules.GetIMPORTEIVAValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteIMPORTEIVA];
end;

function TFacturasClienteBusinessProcessorRules.GetOldIMPORTEIVAValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_FacturasClienteIMPORTEIVA];
end;

procedure TFacturasClienteBusinessProcessorRules.SetIMPORTEIVAValue(const aValue: Currency);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteIMPORTEIVA] := aValue;
end;

function TFacturasClienteBusinessProcessorRules.GetIMPORTETOTALValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteIMPORTETOTAL];
end;

function TFacturasClienteBusinessProcessorRules.GetOldIMPORTETOTALValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_FacturasClienteIMPORTETOTAL];
end;

procedure TFacturasClienteBusinessProcessorRules.SetIMPORTETOTALValue(const aValue: Currency);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteIMPORTETOTAL] := aValue;
end;

function TFacturasClienteBusinessProcessorRules.GetDESCUENTOValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteDESCUENTO];
end;

function TFacturasClienteBusinessProcessorRules.GetOldDESCUENTOValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_FacturasClienteDESCUENTO];
end;

procedure TFacturasClienteBusinessProcessorRules.SetDESCUENTOValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteDESCUENTO] := aValue;
end;

function TFacturasClienteBusinessProcessorRules.GetIMPORTEDESCUENTOValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteIMPORTEDESCUENTO];
end;

function TFacturasClienteBusinessProcessorRules.GetOldIMPORTEDESCUENTOValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_FacturasClienteIMPORTEDESCUENTO];
end;

procedure TFacturasClienteBusinessProcessorRules.SetIMPORTEDESCUENTOValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteIMPORTEDESCUENTO] := aValue;
end;

function TFacturasClienteBusinessProcessorRules.GetOBSERVACIONESValue: IROStrings;
begin
  result := NewROStrings();
  result.Text := BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteOBSERVACIONES];
end;

function TFacturasClienteBusinessProcessorRules.GetOldOBSERVACIONESValue: IROStrings;
begin
  result := NewROStrings();
  result.Text := BusinessProcessor.CurrentChange.OldValueByName[fld_FacturasClienteOBSERVACIONES];
end;

procedure TFacturasClienteBusinessProcessorRules.SetOBSERVACIONESValue(const aValue: IROStrings);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteOBSERVACIONES] := aValue.Text;
end;

function TFacturasClienteBusinessProcessorRules.GetFORMAPAGOValue: IROStrings;
begin
  result := NewROStrings();
  result.Text := BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteFORMAPAGO];
end;

function TFacturasClienteBusinessProcessorRules.GetOldFORMAPAGOValue: IROStrings;
begin
  result := NewROStrings();
  result.Text := BusinessProcessor.CurrentChange.OldValueByName[fld_FacturasClienteFORMAPAGO];
end;

procedure TFacturasClienteBusinessProcessorRules.SetFORMAPAGOValue(const aValue: IROStrings);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteFORMAPAGO] := aValue.Text;
end;

function TFacturasClienteBusinessProcessorRules.GetCODIGOCONTACTOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteCODIGOCONTACTO];
end;

function TFacturasClienteBusinessProcessorRules.GetOldCODIGOCONTACTOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_FacturasClienteCODIGOCONTACTO];
end;

procedure TFacturasClienteBusinessProcessorRules.SetCODIGOCONTACTOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteCODIGOCONTACTO] := aValue;
end;

function TFacturasClienteBusinessProcessorRules.GetNIFCIFValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteNIFCIF];
end;

function TFacturasClienteBusinessProcessorRules.GetOldNIFCIFValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_FacturasClienteNIFCIF];
end;

procedure TFacturasClienteBusinessProcessorRules.SetNIFCIFValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteNIFCIF] := aValue;
end;

function TFacturasClienteBusinessProcessorRules.GetNOMBREValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteNOMBRE];
end;

function TFacturasClienteBusinessProcessorRules.GetOldNOMBREValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_FacturasClienteNOMBRE];
end;

procedure TFacturasClienteBusinessProcessorRules.SetNOMBREValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteNOMBRE] := aValue;
end;

function TFacturasClienteBusinessProcessorRules.GetCALLEValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteCALLE];
end;

function TFacturasClienteBusinessProcessorRules.GetOldCALLEValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_FacturasClienteCALLE];
end;

procedure TFacturasClienteBusinessProcessorRules.SetCALLEValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteCALLE] := aValue;
end;

function TFacturasClienteBusinessProcessorRules.GetPROVINCIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClientePROVINCIA];
end;

function TFacturasClienteBusinessProcessorRules.GetOldPROVINCIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_FacturasClientePROVINCIA];
end;

procedure TFacturasClienteBusinessProcessorRules.SetPROVINCIAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClientePROVINCIA] := aValue;
end;

function TFacturasClienteBusinessProcessorRules.GetCODIGOPOSTALValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteCODIGOPOSTAL];
end;

function TFacturasClienteBusinessProcessorRules.GetOldCODIGOPOSTALValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_FacturasClienteCODIGOPOSTAL];
end;

procedure TFacturasClienteBusinessProcessorRules.SetCODIGOPOSTALValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteCODIGOPOSTAL] := aValue;
end;

function TFacturasClienteBusinessProcessorRules.GetPOBLACIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClientePOBLACION];
end;

function TFacturasClienteBusinessProcessorRules.GetOldPOBLACIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_FacturasClientePOBLACION];
end;

procedure TFacturasClienteBusinessProcessorRules.SetPOBLACIONValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClientePOBLACION] := aValue;
end;

function TFacturasClienteBusinessProcessorRules.GetCODIGOOBRAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteCODIGOOBRA];
end;

function TFacturasClienteBusinessProcessorRules.GetOldCODIGOOBRAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_FacturasClienteCODIGOOBRA];
end;

procedure TFacturasClienteBusinessProcessorRules.SetCODIGOOBRAValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_FacturasClienteCODIGOOBRA] := aValue;
end;


{ TDetallesFacturasClienteBusinessProcessorRules }
constructor TDetallesFacturasClienteBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TDetallesFacturasClienteBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TDetallesFacturasClienteBusinessProcessorRules.GetCODIGOFACTURAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_DetallesFacturasClienteCODIGOFACTURA];
end;

function TDetallesFacturasClienteBusinessProcessorRules.GetOldCODIGOFACTURAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_DetallesFacturasClienteCODIGOFACTURA];
end;

procedure TDetallesFacturasClienteBusinessProcessorRules.SetCODIGOFACTURAValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_DetallesFacturasClienteCODIGOFACTURA] := aValue;
end;

function TDetallesFacturasClienteBusinessProcessorRules.GetNUMCONCEPTOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_DetallesFacturasClienteNUMCONCEPTO];
end;

function TDetallesFacturasClienteBusinessProcessorRules.GetOldNUMCONCEPTOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_DetallesFacturasClienteNUMCONCEPTO];
end;

procedure TDetallesFacturasClienteBusinessProcessorRules.SetNUMCONCEPTOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_DetallesFacturasClienteNUMCONCEPTO] := aValue;
end;

function TDetallesFacturasClienteBusinessProcessorRules.GetPOSICIONValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_DetallesFacturasClientePOSICION];
end;

function TDetallesFacturasClienteBusinessProcessorRules.GetOldPOSICIONValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_DetallesFacturasClientePOSICION];
end;

procedure TDetallesFacturasClienteBusinessProcessorRules.SetPOSICIONValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_DetallesFacturasClientePOSICION] := aValue;
end;

function TDetallesFacturasClienteBusinessProcessorRules.GetTIPOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_DetallesFacturasClienteTIPO];
end;

function TDetallesFacturasClienteBusinessProcessorRules.GetOldTIPOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_DetallesFacturasClienteTIPO];
end;

procedure TDetallesFacturasClienteBusinessProcessorRules.SetTIPOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_DetallesFacturasClienteTIPO] := aValue;
end;

function TDetallesFacturasClienteBusinessProcessorRules.GetDESCRIPCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_DetallesFacturasClienteDESCRIPCION];
end;

function TDetallesFacturasClienteBusinessProcessorRules.GetOldDESCRIPCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_DetallesFacturasClienteDESCRIPCION];
end;

procedure TDetallesFacturasClienteBusinessProcessorRules.SetDESCRIPCIONValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_DetallesFacturasClienteDESCRIPCION] := aValue;
end;

function TDetallesFacturasClienteBusinessProcessorRules.GetCANTIDADValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_DetallesFacturasClienteCANTIDAD];
end;

function TDetallesFacturasClienteBusinessProcessorRules.GetOldCANTIDADValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_DetallesFacturasClienteCANTIDAD];
end;

procedure TDetallesFacturasClienteBusinessProcessorRules.SetCANTIDADValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_DetallesFacturasClienteCANTIDAD] := aValue;
end;

function TDetallesFacturasClienteBusinessProcessorRules.GetIMPORTEUNIDADValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_DetallesFacturasClienteIMPORTEUNIDAD];
end;

function TDetallesFacturasClienteBusinessProcessorRules.GetOldIMPORTEUNIDADValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_DetallesFacturasClienteIMPORTEUNIDAD];
end;

procedure TDetallesFacturasClienteBusinessProcessorRules.SetIMPORTEUNIDADValue(const aValue: Currency);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_DetallesFacturasClienteIMPORTEUNIDAD] := aValue;
end;

function TDetallesFacturasClienteBusinessProcessorRules.GetIMPORTETOTALValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_DetallesFacturasClienteIMPORTETOTAL];
end;

function TDetallesFacturasClienteBusinessProcessorRules.GetOldIMPORTETOTALValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_DetallesFacturasClienteIMPORTETOTAL];
end;

procedure TDetallesFacturasClienteBusinessProcessorRules.SetIMPORTETOTALValue(const aValue: Currency);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_DetallesFacturasClienteIMPORTETOTAL] := aValue;
end;


{ TInformeCabeceraFacturaClienteBusinessProcessorRules }
constructor TInformeCabeceraFacturaClienteBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TInformeCabeceraFacturaClienteBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetCODIGOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteCODIGO];
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetOldCODIGOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeCabeceraFacturaClienteCODIGO];
end;

procedure TInformeCabeceraFacturaClienteBusinessProcessorRules.SetCODIGOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteCODIGO] := aValue;
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetFECHAALTAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteFECHAALTA];
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetOldFECHAALTAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeCabeceraFacturaClienteFECHAALTA];
end;

procedure TInformeCabeceraFacturaClienteBusinessProcessorRules.SetFECHAALTAValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteFECHAALTA] := aValue;
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetFECHAVENCIMIENTOValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteFECHAVENCIMIENTO];
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetOldFECHAVENCIMIENTOValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeCabeceraFacturaClienteFECHAVENCIMIENTO];
end;

procedure TInformeCabeceraFacturaClienteBusinessProcessorRules.SetFECHAVENCIMIENTOValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteFECHAVENCIMIENTO] := aValue;
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetUSUARIOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteUSUARIO];
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetOldUSUARIOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeCabeceraFacturaClienteUSUARIO];
end;

procedure TInformeCabeceraFacturaClienteBusinessProcessorRules.SetUSUARIOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteUSUARIO] := aValue;
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetCLASEFACTURAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteCLASEFACTURA];
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetOldCLASEFACTURAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeCabeceraFacturaClienteCLASEFACTURA];
end;

procedure TInformeCabeceraFacturaClienteBusinessProcessorRules.SetCLASEFACTURAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteCLASEFACTURA] := aValue;
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetFECHAFACTURAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteFECHAFACTURA];
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetOldFECHAFACTURAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeCabeceraFacturaClienteFECHAFACTURA];
end;

procedure TInformeCabeceraFacturaClienteBusinessProcessorRules.SetFECHAFACTURAValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteFECHAFACTURA] := aValue;
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetREFERENCIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteREFERENCIA];
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetOldREFERENCIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeCabeceraFacturaClienteREFERENCIA];
end;

procedure TInformeCabeceraFacturaClienteBusinessProcessorRules.SetREFERENCIAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteREFERENCIA] := aValue;
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetPAGADAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClientePAGADA];
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetOldPAGADAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeCabeceraFacturaClientePAGADA];
end;

procedure TInformeCabeceraFacturaClienteBusinessProcessorRules.SetPAGADAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClientePAGADA] := aValue;
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetCODIGOCONTACTOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteCODIGOCONTACTO];
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetOldCODIGOCONTACTOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeCabeceraFacturaClienteCODIGOCONTACTO];
end;

procedure TInformeCabeceraFacturaClienteBusinessProcessorRules.SetCODIGOCONTACTOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteCODIGOCONTACTO] := aValue;
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetBASEIMPONIBLEValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteBASEIMPONIBLE];
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetOldBASEIMPONIBLEValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeCabeceraFacturaClienteBASEIMPONIBLE];
end;

procedure TInformeCabeceraFacturaClienteBusinessProcessorRules.SetBASEIMPONIBLEValue(const aValue: Currency);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteBASEIMPONIBLE] := aValue;
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetIVAValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteIVA];
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetOldIVAValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeCabeceraFacturaClienteIVA];
end;

procedure TInformeCabeceraFacturaClienteBusinessProcessorRules.SetIVAValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteIVA] := aValue;
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetIMPORTEIVAValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteIMPORTEIVA];
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetOldIMPORTEIVAValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeCabeceraFacturaClienteIMPORTEIVA];
end;

procedure TInformeCabeceraFacturaClienteBusinessProcessorRules.SetIMPORTEIVAValue(const aValue: Currency);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteIMPORTEIVA] := aValue;
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetIMPORTETOTALValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteIMPORTETOTAL];
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetOldIMPORTETOTALValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeCabeceraFacturaClienteIMPORTETOTAL];
end;

procedure TInformeCabeceraFacturaClienteBusinessProcessorRules.SetIMPORTETOTALValue(const aValue: Currency);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteIMPORTETOTAL] := aValue;
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetOBSERVACIONESValue: IROStrings;
begin
  result := NewROStrings();
  result.Text := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteOBSERVACIONES];
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetOldOBSERVACIONESValue: IROStrings;
begin
  result := NewROStrings();
  result.Text := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeCabeceraFacturaClienteOBSERVACIONES];
end;

procedure TInformeCabeceraFacturaClienteBusinessProcessorRules.SetOBSERVACIONESValue(const aValue: IROStrings);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteOBSERVACIONES] := aValue.Text;
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetFORMAPAGOValue: IROStrings;
begin
  result := NewROStrings();
  result.Text := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteFORMAPAGO];
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetOldFORMAPAGOValue: IROStrings;
begin
  result := NewROStrings();
  result.Text := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeCabeceraFacturaClienteFORMAPAGO];
end;

procedure TInformeCabeceraFacturaClienteBusinessProcessorRules.SetFORMAPAGOValue(const aValue: IROStrings);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteFORMAPAGO] := aValue.Text;
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetNIFCIFValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteNIFCIF];
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetOldNIFCIFValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeCabeceraFacturaClienteNIFCIF];
end;

procedure TInformeCabeceraFacturaClienteBusinessProcessorRules.SetNIFCIFValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteNIFCIF] := aValue;
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetNOMBREValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteNOMBRE];
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetOldNOMBREValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeCabeceraFacturaClienteNOMBRE];
end;

procedure TInformeCabeceraFacturaClienteBusinessProcessorRules.SetNOMBREValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteNOMBRE] := aValue;
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetCALLEValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteCALLE];
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetOldCALLEValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeCabeceraFacturaClienteCALLE];
end;

procedure TInformeCabeceraFacturaClienteBusinessProcessorRules.SetCALLEValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteCALLE] := aValue;
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetPROVINCIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClientePROVINCIA];
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetOldPROVINCIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeCabeceraFacturaClientePROVINCIA];
end;

procedure TInformeCabeceraFacturaClienteBusinessProcessorRules.SetPROVINCIAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClientePROVINCIA] := aValue;
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetCODIGOPOSTALValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteCODIGOPOSTAL];
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetOldCODIGOPOSTALValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeCabeceraFacturaClienteCODIGOPOSTAL];
end;

procedure TInformeCabeceraFacturaClienteBusinessProcessorRules.SetCODIGOPOSTALValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteCODIGOPOSTAL] := aValue;
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetPOBLACIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClientePOBLACION];
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetOldPOBLACIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeCabeceraFacturaClientePOBLACION];
end;

procedure TInformeCabeceraFacturaClienteBusinessProcessorRules.SetPOBLACIONValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClientePOBLACION] := aValue;
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetCODIGOOBRAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteCODIGOOBRA];
end;

function TInformeCabeceraFacturaClienteBusinessProcessorRules.GetOldCODIGOOBRAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeCabeceraFacturaClienteCODIGOOBRA];
end;

procedure TInformeCabeceraFacturaClienteBusinessProcessorRules.SetCODIGOOBRAValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeCabeceraFacturaClienteCODIGOOBRA] := aValue;
end;


{ TInformeDetallesFacturaClienteBusinessProcessorRules }
constructor TInformeDetallesFacturaClienteBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TInformeDetallesFacturaClienteBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TInformeDetallesFacturaClienteBusinessProcessorRules.GetCODIGOFACTURAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeDetallesFacturaClienteCODIGOFACTURA];
end;

function TInformeDetallesFacturaClienteBusinessProcessorRules.GetOldCODIGOFACTURAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeDetallesFacturaClienteCODIGOFACTURA];
end;

procedure TInformeDetallesFacturaClienteBusinessProcessorRules.SetCODIGOFACTURAValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeDetallesFacturaClienteCODIGOFACTURA] := aValue;
end;

function TInformeDetallesFacturaClienteBusinessProcessorRules.GetNUMCONCEPTOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeDetallesFacturaClienteNUMCONCEPTO];
end;

function TInformeDetallesFacturaClienteBusinessProcessorRules.GetOldNUMCONCEPTOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeDetallesFacturaClienteNUMCONCEPTO];
end;

procedure TInformeDetallesFacturaClienteBusinessProcessorRules.SetNUMCONCEPTOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeDetallesFacturaClienteNUMCONCEPTO] := aValue;
end;

function TInformeDetallesFacturaClienteBusinessProcessorRules.GetDESCRIPCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeDetallesFacturaClienteDESCRIPCION];
end;

function TInformeDetallesFacturaClienteBusinessProcessorRules.GetOldDESCRIPCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeDetallesFacturaClienteDESCRIPCION];
end;

procedure TInformeDetallesFacturaClienteBusinessProcessorRules.SetDESCRIPCIONValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeDetallesFacturaClienteDESCRIPCION] := aValue;
end;

function TInformeDetallesFacturaClienteBusinessProcessorRules.GetCANTIDADValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeDetallesFacturaClienteCANTIDAD];
end;

function TInformeDetallesFacturaClienteBusinessProcessorRules.GetOldCANTIDADValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeDetallesFacturaClienteCANTIDAD];
end;

procedure TInformeDetallesFacturaClienteBusinessProcessorRules.SetCANTIDADValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeDetallesFacturaClienteCANTIDAD] := aValue;
end;

function TInformeDetallesFacturaClienteBusinessProcessorRules.GetIMPORTEUNIDADValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeDetallesFacturaClienteIMPORTEUNIDAD];
end;

function TInformeDetallesFacturaClienteBusinessProcessorRules.GetOldIMPORTEUNIDADValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeDetallesFacturaClienteIMPORTEUNIDAD];
end;

procedure TInformeDetallesFacturaClienteBusinessProcessorRules.SetIMPORTEUNIDADValue(const aValue: Currency);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeDetallesFacturaClienteIMPORTEUNIDAD] := aValue;
end;

function TInformeDetallesFacturaClienteBusinessProcessorRules.GetIMPORTETOTALValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeDetallesFacturaClienteIMPORTETOTAL];
end;

function TInformeDetallesFacturaClienteBusinessProcessorRules.GetOldIMPORTETOTALValue: Currency;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeDetallesFacturaClienteIMPORTETOTAL];
end;

procedure TInformeDetallesFacturaClienteBusinessProcessorRules.SetIMPORTETOTALValue(const aValue: Currency);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeDetallesFacturaClienteIMPORTETOTAL] := aValue;
end;

function TInformeDetallesFacturaClienteBusinessProcessorRules.GetTIPOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeDetallesFacturaClienteTIPO];
end;

function TInformeDetallesFacturaClienteBusinessProcessorRules.GetOldTIPOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeDetallesFacturaClienteTIPO];
end;

procedure TInformeDetallesFacturaClienteBusinessProcessorRules.SetTIPOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeDetallesFacturaClienteTIPO] := aValue;
end;

function TInformeDetallesFacturaClienteBusinessProcessorRules.GetPOSICIONValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_InformeDetallesFacturaClientePOSICION];
end;

function TInformeDetallesFacturaClienteBusinessProcessorRules.GetOldPOSICIONValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_InformeDetallesFacturaClientePOSICION];
end;

procedure TInformeDetallesFacturaClienteBusinessProcessorRules.SetPOSICIONValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_InformeDetallesFacturaClientePOSICION] := aValue;
end;


{ TDarReferenciaFacturaProformaBusinessProcessorRules }
constructor TDarReferenciaFacturaProformaBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TDarReferenciaFacturaProformaBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TDarReferenciaFacturaProformaBusinessProcessorRules.GetREFERENCIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_DarReferenciaFacturaProformaREFERENCIA];
end;

function TDarReferenciaFacturaProformaBusinessProcessorRules.GetOldREFERENCIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_DarReferenciaFacturaProformaREFERENCIA];
end;

procedure TDarReferenciaFacturaProformaBusinessProcessorRules.SetREFERENCIAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_DarReferenciaFacturaProformaREFERENCIA] := aValue;
end;


initialization
  RegisterBusinessProcessorRules(RID_DarReferenciaFacturaDelta, TDarReferenciaFacturaBusinessProcessorRules);
  RegisterBusinessProcessorRules(RID_FacturasClienteDelta, TFacturasClienteBusinessProcessorRules);
  RegisterBusinessProcessorRules(RID_DetallesFacturasClienteDelta, TDetallesFacturasClienteBusinessProcessorRules);
  RegisterBusinessProcessorRules(RID_InformeCabeceraFacturaClienteDelta, TInformeCabeceraFacturaClienteBusinessProcessorRules);
  RegisterBusinessProcessorRules(RID_InformeDetallesFacturaClienteDelta, TInformeDetallesFacturaClienteBusinessProcessorRules);
  RegisterBusinessProcessorRules(RID_DarReferenciaFacturaProformaDelta, TDarReferenciaFacturaProformaBusinessProcessorRules);

end.
